kind: pipeline
type: docker
name: CI


trigger:
  event:
    - push

steps:
  - name: build
    image: mcr.microsoft.com/dotnet/sdk:8.0
    commands:
      - cd Sources
      - dotnet restore mastermindSansMaui.sln
      - dotnet build mastermindSansMaui.sln -c Release --no-restore
      - dotnet publish mastermindSansMaui.sln -c Release --no-restore -o $CI_PROJECT_DIR/build/release
  #- name: build-MauiSpark
  #  image: mcr.microsoft.com/dotnet/sdk:8.0
  #  commands:
  #    - mkdir /usr/lib/android-sdk
  #    - cd /usr/lib/android-sdk
  #    - wget -O commandlinetools.zip https://dl.google.com/android/repository/commandlinetools-linux-9123335_latest.zip
  #    - apt update && apt install unzip default-jdk -y
  #    - unzip commandlinetools.zip
  #    - yes | /usr/lib/android-sdk/cmdline-tools/bin/sdkmanager "platform-tools" "platforms;android-34" "build-tools;34.0.0" --sdk_root=/usr/lib/android-sdk/
  #    - cd /drone/src/Sources
  #    - dotnet --version
  #    - dotnet workload install maui-android
  #    - dotnet restore MauiSpark/MauiSpark.csproj
  #    - dotnet build MauiSpark/MauiSpark.csproj -c Release --no-restore /p:AndroidSdkDirectory=/usr/lib/android-sdk/ -property:Aapt2ToolPath=/usr/lib/android-sdk/build-tools/34.0.0
  - name: tests
    image: mcr.microsoft.com/dotnet/sdk:8.0
    commands:
      - cd Sources/
      - dotnet restore mastermindSansMaui.sln
      - dotnet test mastermindSansMaui.sln --no-restore
    depends_on: [build]
  - name: code-inspection
    image: hub.codefirst.iut.uca.fr/marc.chevaldonne/codefirst-dronesonarplugin-dotnet8
    secrets: [ SECRET_SONAR_LOGIN ]
    environment:
      sonar_host: https://codefirst.iut.uca.fr/sonar/
      sonar_token:
        from_secret: sonar_token
      project_key: celestebarbosa-mastermind
      coverage_exclusions: "UnitTesting/**,ConsoleApp/**"
    commands:
      - cd Sources/
      - dotnet restore mastermindSansMaui.sln
      - dotnet sonarscanner begin /k:$${project_key} /d:sonar.host.url=$${sonar_host} /d:sonar.coverageReportPaths="coveragereport/SonarQube.xml" /d:sonar.coverage.exclusions=$${coverage_exclusions} /d:sonar.login=$${sonar_token} 
      - dotnet build mastermindSansMaui.sln -c Release --no-restore
      - dotnet test mastermindSansMaui.sln --logger trx --no-restore /p:CollectCoverage=true /p:CoverletOutputFormat=cobertura --collect "XPlat Code Coverage"
      - reportgenerator -reports:"**/coverage.cobertura.xml" -reporttypes:SonarQube -targetdir:"coveragereport"
      - dotnet publish mastermindSansMaui.sln -c Release --no-restore -o CI_PROJECT_DIR/build/release
      - dotnet sonarscanner end /d:sonar.login=$${sonar_token}
  - name: generate-and-deploy-docs
    image: hub.codefirst.iut.uca.fr/thomas.bellembois/codefirst-docdeployer
    failure: ignore
    volumes:
      - name: docs
        path: /docs
    commands:
      - /entrypoint.sh
    when:
      branch:
        - master